Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 6693)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 6694)
@@ -164,10 +164,4 @@
       <DependentUpon>RunCollectionBoxPlotView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCollectionModificationEvaluatorView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="RunCollectionModificationEvaluatorView.Designer.cs">
-      <DependentUpon>RunCollectionModificationEvaluatorView.cs</DependentUpon>
-    </Compile>
     <Compile Include="RunCollectionComparisonConstraintView.cs">
       <SubType>UserControl</SubType>
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs	(revision 6693)
+++ 	(revision )
@@ -1,155 +1,0 @@
-﻿namespace HeuristicLab.Optimization.Views {
-  partial class RunCollectionModificationEvaluatorView {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary>
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Windows Form Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.evaluateButton = new System.Windows.Forms.Button();
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.runsTabPage = new System.Windows.Forms.TabPage();
-      this.runCollectionViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.modifiersTabPage = new System.Windows.Forms.TabPage();
-      this.modifiersViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.tabControl.SuspendLayout();
-      this.runsTabPage.SuspendLayout();
-      this.modifiersTabPage.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // nameTextBox
-      // 
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Size = new System.Drawing.Size(419, 20);
-      // 
-      // infoLabel
-      // 
-      this.infoLabel.Location = new System.Drawing.Point(483, 3);
-      // 
-      // evaluateButton
-      // 
-      this.evaluateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.evaluateButton.Location = new System.Drawing.Point(6, 266);
-      this.evaluateButton.Name = "evaluateButton";
-      this.evaluateButton.Size = new System.Drawing.Size(75, 23);
-      this.evaluateButton.TabIndex = 4;
-      this.evaluateButton.Text = "&Evaluate";
-      this.evaluateButton.UseVisualStyleBackColor = true;
-      this.evaluateButton.Click += new System.EventHandler(this.evaluateButton_Click);
-      // 
-      // tabControl
-      // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl.Controls.Add(this.runsTabPage);
-      this.tabControl.Controls.Add(this.modifiersTabPage);
-      this.tabControl.Location = new System.Drawing.Point(3, 26);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(496, 318);
-      this.tabControl.TabIndex = 5;
-      // 
-      // runsTabPage
-      // 
-      this.runsTabPage.Controls.Add(this.runCollectionViewHost);
-      this.runsTabPage.Location = new System.Drawing.Point(4, 22);
-      this.runsTabPage.Name = "runsTabPage";
-      this.runsTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.runsTabPage.Size = new System.Drawing.Size(488, 292);
-      this.runsTabPage.TabIndex = 0;
-      this.runsTabPage.Text = "Runs";
-      this.runsTabPage.UseVisualStyleBackColor = true;
-      // 
-      // runCollectionViewHost
-      // 
-      this.runCollectionViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.runCollectionViewHost.Caption = "View";
-      this.runCollectionViewHost.Content = null;
-      this.runCollectionViewHost.Enabled = false;
-      this.runCollectionViewHost.Location = new System.Drawing.Point(6, 6);
-      this.runCollectionViewHost.Name = "runCollectionViewHost";
-      this.runCollectionViewHost.ReadOnly = false;
-      this.runCollectionViewHost.Size = new System.Drawing.Size(476, 280);
-      this.runCollectionViewHost.TabIndex = 0;
-      this.runCollectionViewHost.ViewsLabelVisible = true;
-      this.runCollectionViewHost.ViewType = null;
-      // 
-      // modifiersTabPage
-      // 
-      this.modifiersTabPage.Controls.Add(this.modifiersViewHost);
-      this.modifiersTabPage.Controls.Add(this.evaluateButton);
-      this.modifiersTabPage.Location = new System.Drawing.Point(4, 22);
-      this.modifiersTabPage.Name = "modifiersTabPage";
-      this.modifiersTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.modifiersTabPage.Size = new System.Drawing.Size(488, 292);
-      this.modifiersTabPage.TabIndex = 1;
-      this.modifiersTabPage.Text = "Modifiers";
-      this.modifiersTabPage.UseVisualStyleBackColor = true;
-      // 
-      // modifiersViewHost
-      // 
-      this.modifiersViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.modifiersViewHost.Caption = "View";
-      this.modifiersViewHost.Content = null;
-      this.modifiersViewHost.Enabled = false;
-      this.modifiersViewHost.Location = new System.Drawing.Point(6, 6);
-      this.modifiersViewHost.Name = "modifiersViewHost";
-      this.modifiersViewHost.ReadOnly = false;
-      this.modifiersViewHost.Size = new System.Drawing.Size(476, 254);
-      this.modifiersViewHost.TabIndex = 0;
-      this.modifiersViewHost.ViewsLabelVisible = true;
-      this.modifiersViewHost.ViewType = null;
-      // 
-      // RunCollectionModificationEvaluatorView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.Controls.Add(this.tabControl);
-      this.Name = "RunCollectionModificationEvaluatorView";
-      this.Size = new System.Drawing.Size(502, 347);
-      this.Controls.SetChildIndex(this.tabControl, 0);
-      this.Controls.SetChildIndex(this.infoLabel, 0);
-      this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.nameLabel, 0);
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.tabControl.ResumeLayout(false);
-      this.runsTabPage.ResumeLayout(false);
-      this.modifiersTabPage.ResumeLayout(false);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Button evaluateButton;
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage runsTabPage;
-    private MainForm.WindowsForms.ViewHost runCollectionViewHost;
-    private System.Windows.Forms.TabPage modifiersTabPage;
-    private MainForm.WindowsForms.ViewHost modifiersViewHost;
-  }
-}
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs	(revision 6693)
+++ 	(revision )
@@ -1,83 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Data;
-using System.Drawing;
-using System.Linq;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Optimization.Views {
-
-  [View("RunCollection Calculator View")]
-  [Content(typeof(RunCollectionModificationEvaluator), IsDefaultView = true)]
-  public sealed partial class RunCollectionModificationEvaluatorView : NamedItemView {
-
-    public new RunCollectionModificationEvaluator Content {
-      get { return (RunCollectionModificationEvaluator)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public RunCollectionModificationEvaluatorView() {
-      InitializeComponent();
-    }
-
-    protected override void DeregisterContentEvents() {
-      Content.RunCollectionParameter.ValueChanged -= new EventHandler(RunCollection_Changed);
-      Content.ModifiersParameter.ValueChanged -= new EventHandler(Modifiers_Changed);
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.RunCollectionParameter.ValueChanged += new EventHandler(RunCollection_Changed);
-      Content.ModifiersParameter.ValueChanged += new EventHandler(Modifiers_Changed);
-    }
-
-    #region Event Handlers (Content)
-    private void RunCollection_Changed(object sender, EventArgs args) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(RunCollection_Changed), sender, args);
-      else
-        runCollectionViewHost.Content = Content.RunCollection;
-    }
-    private void Modifiers_Changed(object sender, EventArgs args) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Modifiers_Changed), sender, args);
-      else
-        modifiersViewHost.Content = Content.Modifiers;
-    }
-    #endregion
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        runCollectionViewHost.Content = null;
-        modifiersViewHost.Content = null;
-      } else {
-        runCollectionViewHost.Content = Content.RunCollection;
-        modifiersViewHost.Content = Content.Modifiers;
-      }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      evaluateButton.Enabled = Content != null;
-    }
-
-    #region Event Handlers (child controls)
-    private void evaluateButton_Click(object sender, EventArgs e) {
-      evaluateButton.Enabled = false;
-      var worker = new BackgroundWorker();
-      worker.DoWork += (s, a) => Content.Evaluate();
-      worker.RunWorkerCompleted += (s, a) => { evaluateButton.Enabled = Content != null; };
-      worker.RunWorkerAsync();
-    }        
-    #endregion
-
-  }
-}
Index: trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6693)
+++ trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6694)
@@ -143,5 +143,4 @@
     <Compile Include="Problems\Problem.cs" />
     <Compile Include="RunCollectionFormulaModifer.cs" />
-    <Compile Include="RunCollectionModificationEvaluator.cs" />
     <Compile Include="RunCollectionConstraints\RunCollectionComparisonConstraint.cs" />
     <Compile Include="RunCollectionConstraints\RunCollectionConstraintCollection.cs" />
Index: trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionModificationEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/RunCollectionModificationEvaluator.cs	(revision 6693)
+++ 	(revision )
@@ -1,93 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Optimization {
-  [Item("RunCollection Modification Evaluator", "Applies a series of RunCollection modifiers.")]
-  [Creatable("Testing & Analysis")]
-  [StorableClass]
-  public class RunCollectionModificationEvaluator : ParameterizedNamedItem, IStorableContent {
-
-    public string Filename { get; set; }
-
-    #region Parameters
-    public ValueParameter<RunCollection> RunCollectionParameter {
-      get { return (ValueParameter<RunCollection>)Parameters["RunCollection"]; }
-    }
-
-    public ValueParameter<CheckedItemList<IRunCollectionModifier>> ModifiersParameter {
-      get { return (ValueParameter<CheckedItemList<IRunCollectionModifier>>)Parameters["Modifiers"]; }
-    }
-    #endregion
-
-    #region Parameter Values
-    public RunCollection RunCollection {
-      get { return RunCollectionParameter.Value; }
-    }
-    public CheckedItemList<IRunCollectionModifier> Modifiers {
-      get { return ModifiersParameter.Value; }
-    }
-    #endregion
-
-    #region Construction & Cloning
-    [StorableConstructor]
-    protected RunCollectionModificationEvaluator(bool deserializing) : base(deserializing) { }
-    protected RunCollectionModificationEvaluator(RunCollectionModificationEvaluator original, Cloner cloner) : base(original, cloner) { }
-    public RunCollectionModificationEvaluator() {
-      Parameters.Add(new ValueParameter<RunCollection>("RunCollection", "The RunCollection to be modified.", new RunCollection()));
-      Parameters.Add(new ValueParameter<CheckedItemList<IRunCollectionModifier>>("Modifiers", "A list of modifiers to be applied to the run collection.", new CheckedItemList<IRunCollectionModifier>()));
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new RunCollectionModificationEvaluator(this, cloner);
-    }
-    #endregion
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      if (RunCollection != null && RunCollection.Modifiers != null) {
-        RunCollection.Modifiers.AddRange(Modifiers);
-        foreach (var modifier in RunCollection.Modifiers) {
-          RunCollection.Modifiers.SetItemCheckedState(modifier, Modifiers.ItemChecked(modifier));
-        }
-        Modifiers.Clear();
-      }
-    }
-
-    public void Evaluate() {
-      RunCollection.UpdateOfRunsInProgress = true;
-      var runs = RunCollection.Select((r, i) => new { Run = r, r.Visible, Index = i }).ToList();
-      var visibleRuns = runs.Where(r => r.Visible).Select(r => r.Run).ToList();
-      int n = visibleRuns.Count;
-      if (n == 0)
-        return;
-      foreach (var modifier in Modifiers.CheckedItems)
-        modifier.Value.Modify(visibleRuns);
-      if (n != visibleRuns.Count ||
-          runs.Where(r => r.Visible).Zip(visibleRuns, (r1, r2) => r1.Run != r2).Any()) {
-        var runIt = runs.GetEnumerator();
-        var visibleRunIt = visibleRuns.GetEnumerator();
-        var newRuns = new List<IRun>();
-        while (runIt.MoveNext()) {
-          if (!runIt.Current.Visible)
-            newRuns.Add(runIt.Current.Run);
-          else if (visibleRunIt.MoveNext())
-            newRuns.Add(visibleRunIt.Current);
-        }
-        while (visibleRunIt.MoveNext())
-          newRuns.Add(visibleRunIt.Current);
-        RunCollection.Clear();
-        RunCollection.AddRange(newRuns);
-      } else if (runs.Count > 0) { // force update
-        var run = (IRun)runs[0].Run.Clone();
-        RunCollection.Add(run);
-        RunCollection.Remove(run);
-      }
-      RunCollection.UpdateOfRunsInProgress = false;
-    }
-  }
-}