Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/HiveAppointment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/HiveAppointment.cs	(revision 6689)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/HiveAppointment.cs	(revision 6696)
@@ -38,5 +38,5 @@
 
     [XmlIgnore]
-    public int Layer {
+    public new int Layer {
       get { return base.Layer; }
       set { base.Layer = value; }
@@ -44,5 +44,5 @@
 
     [XmlIgnore]
-    public string Group {
+    public new string Group {
       get { return base.Group; }
       set { base.Group = value; }
@@ -50,5 +50,5 @@
 
     [XmlAttribute("Locked")]
-    public bool Locked {
+    public new bool Locked {
       get { return base.Locked; }
       set { base.Locked = value; }
@@ -56,5 +56,5 @@
 
     [XmlIgnore]
-    public Color Color {
+    public new Color Color {
       get { return base.Color; }
       set { base.Color = value; }
@@ -62,5 +62,5 @@
 
     [XmlIgnore]
-    public Color TextColor {
+    public new Color TextColor {
       get { return base.TextColor; }
       set { base.TextColor = value; }
@@ -68,5 +68,5 @@
 
     [XmlIgnore]
-    public Color BorderColor {
+    public new Color BorderColor {
       get { return base.BorderColor; }
       set { base.BorderColor = value; }
@@ -74,5 +74,5 @@
 
     [XmlIgnore]
-    public bool DrawBorder {
+    public new bool DrawBorder {
       get { return base.DrawBorder; }
       set { base.DrawBorder = value; }
@@ -80,5 +80,5 @@
 
     [XmlAttribute("AllDayEvent")]
-    public bool AllDayEvent {
+    public new bool AllDayEvent {
       get { return base.AllDayEvent; }
       set { base.AllDayEvent = value; Changed = true; }
@@ -86,5 +86,5 @@
 
     [XmlAttribute("Recurring")]
-    public bool Recurring {
+    public new bool Recurring {
       get { return base.Recurring; }
       set { base.Recurring = value; Changed = true; }
@@ -98,5 +98,5 @@
 
     [XmlAttribute("EndDate")]
-    public DateTime EndDate {
+    public new DateTime EndDate {
       get { return base.EndDate; }
       set { base.EndDate = value; Changed = true; }
@@ -104,5 +104,5 @@
 
     [XmlAttribute("StartDate")]
-    public DateTime StartDate {
+    public new DateTime StartDate {
       get { return base.StartDate; }
       set { base.StartDate = value; Changed = true; }
@@ -110,5 +110,5 @@
 
     [XmlIgnore]
-    public int AppointmentId {
+    public new int AppointmentId {
       get { return base.AppointmentId; }
       set { base.AppointmentId = value; }
@@ -116,5 +116,5 @@
 
     [XmlElement("Subject")]
-    public string Subject {
+    public new string Subject {
       get { return base.Subject; }
       set { base.Subject = value; }
@@ -122,5 +122,5 @@
 
     [XmlIgnore]
-    public string Location {
+    public new string Location {
       get { return base.Location; }
       set { base.Location = value; }
@@ -128,5 +128,5 @@
 
     [XmlIgnore]
-    public string Note {
+    public new string Note {
       get { return base.Note; }
       set { base.Note = value; }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/Recurrence.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/Recurrence.Designer.cs	(revision 6689)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/Recurrence.Designer.cs	(revision 6696)
@@ -33,7 +33,4 @@
       this.dtpFromTime = new System.Windows.Forms.DateTimePicker();
       this.label6 = new System.Windows.Forms.Label();
-      this.txtDays = new System.Windows.Forms.TextBox();
-      this.label4 = new System.Windows.Forms.Label();
-      this.label7 = new System.Windows.Forms.Label();
       this.btSaveRecurrence = new System.Windows.Forms.Button();
       this.btCancelRecurrence = new System.Windows.Forms.Button();
@@ -130,33 +127,4 @@
       this.label6.Text = "Start Date:";
       // 
-      // txtDays
-      // 
-      this.txtDays.Location = new System.Drawing.Point(160, 13);
-      this.txtDays.Name = "txtDays";
-      this.txtDays.Size = new System.Drawing.Size(30, 20);
-      this.txtDays.TabIndex = 24;
-      this.txtDays.Text = "1";
-      this.txtDays.Visible = false;
-      // 
-      // label4
-      // 
-      this.label4.AutoSize = true;
-      this.label4.Location = new System.Drawing.Point(120, 16);
-      this.label4.Name = "label4";
-      this.label4.Size = new System.Drawing.Size(34, 13);
-      this.label4.TabIndex = 23;
-      this.label4.Text = "Every";
-      this.label4.Visible = false;
-      // 
-      // label7
-      // 
-      this.label7.AutoSize = true;
-      this.label7.Location = new System.Drawing.Point(196, 16);
-      this.label7.Name = "label7";
-      this.label7.Size = new System.Drawing.Size(59, 13);
-      this.label7.TabIndex = 25;
-      this.label7.Text = "week(s) on";
-      this.label7.Visible = false;
-      // 
       // btSaveRecurrence
       // 
@@ -181,11 +149,8 @@
       // gbWeekly
       // 
-      this.gbWeekly.Controls.Add(this.label7);
       this.gbWeekly.Controls.Add(this.cbSunday);
-      this.gbWeekly.Controls.Add(this.txtDays);
       this.gbWeekly.Controls.Add(this.cbSaturday);
       this.gbWeekly.Controls.Add(this.cbFriday);
       this.gbWeekly.Controls.Add(this.cbThursday);
-      this.gbWeekly.Controls.Add(this.label4);
       this.gbWeekly.Controls.Add(this.cbWednesday);
       this.gbWeekly.Controls.Add(this.cbTuesday);
@@ -292,11 +257,8 @@
 
     private System.Windows.Forms.GroupBox gbAppointment;
-    private System.Windows.Forms.TextBox txtDays;
-    private System.Windows.Forms.Label label4;
     private System.Windows.Forms.DateTimePicker dtpEnd;
     private System.Windows.Forms.DateTimePicker dtpStart;
     private System.Windows.Forms.Label label5;
     private System.Windows.Forms.Label label6;
-    private System.Windows.Forms.Label label7;
     private System.Windows.Forms.Button btSaveRecurrence;
     private System.Windows.Forms.Button btCancelRecurrence;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/Recurrence.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/Recurrence.cs	(revision 6689)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/Recurrence.cs	(revision 6696)
@@ -26,9 +26,4 @@
 namespace HeuristicLab.Clients.Hive.Administrator.Views {
 
-  public enum RecurrenceMode {
-    Daily,
-    Weekly
-  }
-
   public partial class Recurrence : Form {
 
@@ -44,7 +39,5 @@
 
     private void btSaveRecurrence_Click(object sender, EventArgs e) {
-      DateTime dateFrom, dateTo;
-      RecurrenceMode mode = RecurrenceMode.Daily;
-      int incWeek = 0;
+      DateTime dateFrom, dateTo;            
       HashSet<DayOfWeek> days = new HashSet<DayOfWeek>();
 
@@ -52,28 +45,25 @@
 
       //check if valid
-      if (InputIsValid()) {
-        //set entity
+      if (InputIsValid())
+      {   
+          dateFrom = DateTime.Parse(dtpStart.Text + " " + dtpFromTime.Text);
+          dateTo = DateTime.Parse(dtpEnd.Text + " " + dtpToTime.Text);
 
-        dateFrom = DateTime.Parse(dtpStart.Text + " " + dtpFromTime.Text);
-        dateTo = DateTime.Parse(dtpEnd.Text + " " + dtpToTime.Text);
+          RecurrentEvent recurrentEvent = new RecurrentEvent()
+          {
+              DateFrom = dateFrom,
+              DateTo = dateTo,
+              AllDay = chbade.Checked,
+              WeekDays = days              
+          };
 
-        if (int.TryParse(txtDays.Text, out incWeek))
-          mode = RecurrenceMode.Weekly;
-        else
-          mode = RecurrenceMode.Daily;
-
-        RecurrentEvent recurrentEvent = new RecurrentEvent() {
-          DateFrom = dateFrom,
-          DateTo = dateTo,
-          AllDay = chbade.Checked,
-          WeekDays = days,
-          IncWeeks = incWeek,
-        };
-
-        //fire delegate and close the dialog
-        dialogClosedDelegate(recurrentEvent);
-        this.Close();
-      } else
-        MessageBox.Show("Incorrect date format", "Schedule Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          //fire delegate and close the dialog
+          dialogClosedDelegate(recurrentEvent);
+          this.Close();
+      }
+      else
+      {
+          MessageBox.Show("Incorrect date format", "Schedule Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+      }
     }
 
@@ -100,11 +90,10 @@
 
     private bool InputIsValid() {
-      DateTime dateFrom, dateTo;
-      int i = 0;
+      DateTime dateFrom, dateTo;      
 
       dateFrom = DateTime.Parse(dtpStart.Text + " " + dtpFromTime.Text);
       dateTo = DateTime.Parse(dtpEnd.Text + " " + dtpToTime.Text);
 
-      if (dateFrom < dateTo && dateFrom.TimeOfDay < dateTo.TimeOfDay && int.TryParse(txtDays.Text, out i))
+      if (dateFrom < dateTo && dateFrom.TimeOfDay < dateTo.TimeOfDay)
         return true;
       else
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/RecurrentEvent.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/RecurrentEvent.cs	(revision 6689)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/RecurrentEvent.cs	(revision 6696)
@@ -27,6 +27,5 @@
     public DateTime DateFrom { get; set; }
     public DateTime DateTo { get; set; }
-    public bool AllDay { get; set; }
-    public int IncWeeks { get; set; }
+    public bool AllDay { get; set; }    
     public HashSet<DayOfWeek> WeekDays { get; set; }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/ScheduleView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/ScheduleView.cs	(revision 6689)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administrator/3.4/Views/ScheduleView.cs	(revision 6696)
@@ -189,8 +189,8 @@
 
     public void DialogClosed(RecurrentEvent e) {
-      CreateDailyRecurrenceAppointments(e.DateFrom, e.DateTo, e.AllDay, e.IncWeeks, e.WeekDays);
-    }
-
-    private void CreateDailyRecurrenceAppointments(DateTime dateFrom, DateTime dateTo, bool allDay, int incWeek, HashSet<DayOfWeek> daysOfWeek) {
+      CreateDailyRecurrenceAppointments(e.DateFrom, e.DateTo, e.AllDay, e.WeekDays);
+    }
+
+    private void CreateDailyRecurrenceAppointments(DateTime dateFrom, DateTime dateTo, bool allDay, HashSet<DayOfWeek> daysOfWeek) {
       DateTime incDate = dateFrom;
       Guid guid = Guid.NewGuid();